module Harold
  class Operation
    VALID_TYPES = %i[add update delete].freeze
    attr_reader :id, :type, :payload, :attributes

    def initialize(id, type, payload = {}, attributes = {})
      unless VALID_TYPES.include?(type)
        raise ArgumentError,
              "#{type} is not a valid type"
      end

      @id = id
      @type = type
      @payload = payload
      @attributes = attributes

      attributes.each_pair do |key, val|
        define_singleton_method(key) { val }
      end
    end
  end
end
